---
name: Bug report
about: Used to report a defect in the source code, scripts, etc... Post questions
  in the Aircrack-ng forum at https://forum.aircrack-ng.org - Read our
  documentation at https://aircrack-ng.org
---

<!--
**Bug reports will only be accepted against the current tip of the master git branch. Anything else will be rejected. Questions must be posted in the discussion board at <https://forum.aircrack-ng.org>.**

For any security-related issues such as exploits, buffer overflows, and such, refer to our security policy: <https://github.com/aircrack-ng/aircrack-ng/security/policy>

Please read the following before reporting the issue:

- Use the search function to check if the bug you're about to post isn't a duplicate. If an existing bug is open and you have new information, update it. If a bug exists and is closed, reopen it and add useful information to it.
- Unless bugs are linked, one bug per ticket.
- Don't worry about any of the items on the right panel (Assignee, Labels or Milestone), we will take care of them.

The following must be taken to the forum first, as in these cases, it often turns out to be a technique issue or the issue is out of our control:

- Not receiving any packets with airodump-ng or any other tool.
- Can't crack a network.
- Wireless card doesn't work.
- Channel -1.

Make sure to check our documentation at <https://aircrack-ng.org/doku.php> as well as our fairly comprehensive FAQ at <https://aircrack-ng.org/doku.php?id=faq>.

**REMOVE ALL OF THE ABOVE TEXT**
-->

# Defect Report

## Issue type

<!--
Please select from one of the following software defect descriptions. Pick the one that best reflects the issue you are experiencing.
-->

- [ ] Defect - Compilation or `make check` issue - Attach `config.log` and provide relevant system information such as `lscpu` - Make sure dependencies are installed
- [ ] Defect - Crash
- [ ] Defect - Incorrect value displayed/received/stored
- [ ] Defect - Unexpected behavior (obvious or confirmed in the forum)

## System information

- OS Name:
- OS Version:
- CPU:
- Wireless card and chipset (if relevant):

## Aircrack-ng version

- Version:
- Commit Revision hash:

## Defect

### Details

<!--
Summarize the issue in a paragraph or two.
-->

### How to reproduce the issue

<!--
A clear and concise list of steps describing how to reproduce the issue, relevant commands and errors/outputs. Such as: What command(s) did you run? What was displayed/happened? What did you expect to happen or be displayed?

Do not use pastebin-type links as they expire, rendering the bug report unactionable. Avoid using images whenever possible. If the content (output or error) is text and can be copy/pasted, enclose it with backticks for readability. If it is large, put it in a file and attach it to the ticket.

GitHub markdown guide: https://guides.github.com/features/mastering-markdown/

Last, but not least, if you aren't familiar with bug reporting, [this](https://www.chiark.greenend.org.uk/~sgtatham/bugs.html) is an excellent read to help you describe bugs accurately.
-->

## Related issues

<!--
Link to any related issue from within the project or outside. Such as GitHub, other bug trackers, relevant forum post, relevant documentation.
-->